/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.personenpruefung.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class PersonPruefungKonfigurationUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp personentyp;

    public de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp getPersonentyp(){
      return personentyp;
    }
    protected final de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp typ;

    public de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp getTyp(){
      return typ;
    }

  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK;

    public de.ivu.elect.business.wahl.entity.WahlterminUK getWahlterminUK(){
      return wahlterminUK;
    }

  public PersonPruefungKonfigurationUK(
de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp personentyp
, de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp typ
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
,   de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK
  ) {
    super();


      this.personentyp = personentyp;
      this.typ = typ;
        this.wahlUK = wahlUK;
      this.wahlterminUK = wahlterminUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((personentyp == null) ? 0 : personentyp.hashCode());
                    result = result + ((typ == null) ? 0 : typ.hashCode());
        
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
                    result = result + ((wahlterminUK == null) ? 0 : wahlterminUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            PersonPruefungKonfigurationUK other = (PersonPruefungKonfigurationUK) obj;

                if (personentyp == null) {
          if (other.personentyp != null) {
            return false;
          }
        } else if (!personentyp.equals(other.personentyp)) {
          return false;
        }
                if (typ == null) {
          if (other.typ != null) {
            return false;
          }
        } else if (!typ.equals(other.typ)) {
          return false;
        }
        
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
                if (wahlterminUK == null) {
          if (other.wahlterminUK != null) {
            return false;
          }
        } else if (!wahlterminUK.equals(other.wahlterminUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return PersonPruefungKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlUK.getAllEntityFieldValues());
    result.addAll(wahlterminUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(PersonPruefungKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL, PersonPruefungKonfigurationConstants.MESSAGE_KEY_PERSONENTYP_EINZAHL, personentyp));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(PersonPruefungKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL, PersonPruefungKonfigurationConstants.MESSAGE_KEY_TYP_EINZAHL, typ));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "PersonPruefungKonfigurationUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"personentyp="+personentyp
                            +", "                +"typ="+typ
                                        +", "                +"wahlUK="+wahlUK
                            +", "                +"wahlterminUK="+wahlterminUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(personentyp);
         list.add(typ);
     return list;
   }

            public static <E extends PersonPruefungKonfiguration> java.util.Map<PersonPruefungKonfigurationUK, E> mappePersonPruefungKonfigurationNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(PersonPruefungKonfiguration::getPersonPruefungKonfigurationUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<PersonPruefungKonfiguration, PersonPruefungKonfigurationUK> getPersonPruefungKonfigurationToUKFunction() {
                return PersonPruefungKonfiguration::getPersonPruefungKonfigurationUK;
                }

}
